
//`timescale 1ns /1 ps

module counter (res,clk,Q);
// bemenetek deklaracioja
input res;

wire res;
input clk;

wire clk;

// kimenetek deklaracioja
output [3:0] Q;

reg [3:0] Q;

// belso jelek
wire J3;
wire K3;
wire T2;
wire T1;
wire D0;

// ezt a reszt kell modositani a sajat tervenek megfeleloen
//##########################################################

parameter kezdoertek = 3; // szamlalo kezdoerteke
// vezerlo fuggvenyek megadasa
assign D0 = ~Q[0];
assign T1 = ~Q[0] & ~Q[2] | ~Q[0] & Q[3];
assign T2 = ~Q[0] & ~Q[1] | ~Q[0] & Q[2] & ~Q[3];
assign J3 = ~Q[0] & ~Q[1];
assign K3 = ~Q[0] & ~Q[1] & ~Q[2];

//##########################################################

// resetelheto D regiszter viselkedesi leirasa
always @ (posedge clk)
begin
if (res == 1'b1)
	begin 
	Q <= #1 kezdoertek; //4'b0000;
	end 
else
	begin
	Q[0] <= #1 D0;
	Q[1] <= #1 T1 ^ Q[1];
	Q[2] <= #1 T2 ^ Q[2];
	Q[3] <= #1 J3 & ~Q[3] | ~K3 & Q[3];
	end
end
endmodule
	